<template>
  <div class="page">
    <div
      v-if="routeFrom && (routeFrom.name === 'Accounts' || routeFrom.name === null)"
      class="back-link"
      @click="$router.push(routeFrom)"
    >
      <b-icon-chevron-left font-scale="1.3" />
      <span>
        Gestion des comptes
      </span>
    </div>
    <div
      v-else
      class="back-link"
      @click="$router.push({ name: 'Users' })"
    >
      <b-icon-chevron-left font-scale="1.3" />
      <span>
        Liste des utilisateurs
      </span>
    </div>
    <div
      class="add-user-form"
    >
      <b-overlay
        id="overlay-background"
        :show="loading"
        :variant="'white'"
        :opacity="0.7"
        :blur="'2px'"
        rounded="sm"
        no-wrap
      />
      <h2>Ajouter un utilisateur</h2>
      <ValidationObserver v-slot="{ handleSubmit }">
        <form style="min-width: 800px;">
          <h3 class="line-header">
            <img
              src="@/assets/icons/face_user.svg"
              alt="Icône silhouette utilisateur"
            /> Utilisateur
          </h3>
          <div class="form-row">
            <div class="form-group col-6">
              <label>{{ labelIdComp }}</label>
              <input
                v-model="form.additional_id"
                class="form-control"
                type="text"
              >
            </div>
          </div>
          <div class="form-row">
            <div class="form-group col-6">
              <label class="required">Nom</label>
              <ValidationProvider ref="last_name" rules="required" v-slot="{ classes, errors }">
                <div class="control" :class="classes">
                  <input
                    v-model="form.last_name"
                    class="form-control"
                    type="text"
                    placeholder="Nom"
                  >
                  <span class="form-errors">{{ errors[0] }}</span>
                </div>
              </ValidationProvider>
            </div>
            <div class="form-group col-6">
              <label class="required">Prénom</label>
              <ValidationProvider ref="first_name" rules="required" v-slot="{ classes, errors }">
                <div class="control" :class="classes">
                  <input
                    v-model="form.first_name"
                    class="form-control"
                    type="text"
                    placeholder="Prénom"
                  >
                  <span class="form-errors">{{ errors[0] }}</span>
                </div>
              </ValidationProvider>
            </div>
          </div>
          <div class="form-row">
            <div class="form-group col-6">
              <label class="required">E-mail</label>
              <ValidationProvider ref="email" rules="required|email" v-slot="{ classes, errors }">
                <div class="control" :class="classes">
                  <input
                    v-model="form.email"
                    class="form-control"
                    type="email"
                    placeholder="email"
                  >
                  <span class="form-errors">{{ errors[0] }}</span>
                </div>
              </ValidationProvider>
            </div>
            <div class="form-group col-6">
              <label>Téléphone de l'utilisateur</label>
              <input
                v-model="form.phone_number"
                class="form-control"
                type="text"
                placeholder="Téléphone"
              >
            </div>
          </div>
          <div class="form-row">
            <div class="form-group col-12">
              <label>Motif de l'inscription</label>
              <textarea
                v-model="form.comments"
                class="form-control"
                rows="1"
              />
            </div>
          </div>

          <h3 class="line-header">
            <img
              src="@/assets/icons/company.svg"
              alt="Icône entreprise"
            /> Organisation
          </h3>
          <UserOrgForm
            v-for="organisation of organisations"
            :key="organisation.position"
            :usergroup="organisation"
            @allowAdd="setCanAddOrganisation"
            @change="updateOrganisation"
            @delete="removeOrganisation"
          />
          <button
            class="add-button"
            :class="{
              disabled: !canAddOrganisation
            }"
            @click.prevent="addOrganisation"
          >
            <b-icon-plus />
            Ajouter une Organisation
          </button>

          <!-- Groupe d'utilisateurs -->
          <h3 class="line-header">
            <img
              src="@/assets/icons/user-group.svg"
              alt="Icône organisation"
            /> Groupes d'utilisateurs
          </h3>
          <UserGroupForm
            v-for="group of groups"
            :key="`group-${group.position}`"
            :usergroup="group"
            @allowAdd="setCanAddGroup"
            @change="updateGroup"
            @delete="removeGroup"
          />
          <button
            class="add-button"
            :class="{
            disabled: !canAddGroup
          }"
            @click.prevent="addGroup"
          >
            <b-icon-plus />
            Ajouter un groupe d'utilisateurs
          </button>

          <div class="form-footer">
            <b-button
              variant="outline-secondary"
              type="submit"
              @click="$router.push(routeFrom && (routeFrom.name === 'Accounts' || routeFrom.name === null) ? routeFrom : { name: 'Users' })"
            >
              Annuler
            </b-button>
            <b-button
              variant="primary"
              type="submit"
              @click.prevent="handleSubmit(checkUsergroups)"
            >
              Confirmer
            </b-button>
          </div>
        </form>
      </ValidationObserver>
    </div>
  </div>
</template>

<script>
import UserOrgForm from '@/components/Forms/UserOrgForm.vue';
import UserGroupForm from '@/components/Forms/UserGroupForm.vue';

import {
  mapState,
  mapMutations,
  mapActions
} from 'vuex';

import { usernamify } from '@/utils';

import Swal from "sweetalert2";
import "sweetalert2/dist/sweetalert2.min.css";

import {
  ValidationObserver,
  ValidationProvider,
  extend,
  configure
} from 'vee-validate';
import { required, email } from 'vee-validate/dist/rules';

extend('required', {
  ...required,
  message: 'Ce champ est requis'
});
extend('email', {
  ...email,
  message: 'Veuillez entrer une adresse email valide'
});

configure({
  classes: {
    valid: 'is-valid',
    invalid: 'is-invalid'
  }
});

const LABEL_ID_COMP = process.env.VUE_APP_LABEL_ID_COMP;

export default {
  name: 'AddUser',

  components: {
    UserOrgForm,
    UserGroupForm,
    ValidationObserver,
    ValidationProvider,
  },

  data() {
    return {
      routeFrom: null,
      loading: false,
      //form
      form: {
        additional_id: null,
        last_name: null,
        first_name: null,
        email: null,
        phone_number: null,
        comments: null
      },
      organisations: [],
      groups: [],
      canAddOrganisation: true,
      canAddGroup: true,
      labelIdComp: LABEL_ID_COMP
    };
  },

  computed: {
    ...mapState('users', [
      'usersError',
      'lastCreatedUser'
    ]),
    ...mapState('organisations', [
      'organisationsList',
    ]),
    ...mapState('form', [
      'currentFormId',
      'currentForm'
    ])
  },

  watch: {
    form: {
      deep: true,
      handler(newValue) {
        this.SET_CURRENT_FORM({
          id: 'addUser',
          form: newValue
        });
      }
    },
    usersError(newValue) {
      if (newValue) {
        for (const [key, value] of Object.entries(newValue)) {
          this.$refs[key].applyResult({
            errors: value,
            valid: false,
            failedRules: {},
          });
        }
      }
    }
  },

  beforeRouteEnter(to, from, next) {
    next((vm) => {
        vm.routeFrom = from;
    });
  },

  created() {
    if (this.currentFormId === 'addUser') {
      this.form = {
        ...this.form,
        ...this.currentForm
      }
    }
  },

  methods: {
    ...mapMutations('form', [
      'SET_CURRENT_FORM'
    ]),
    ...mapMutations('users', [
      'SET_LAST_CREATED_USER'
    ]),
    ...mapActions('users', [
      'CREATE_USER',
      'GET_USERS_LIST'
    ]),

    checkUsergroups() {
      const usergroups = this.organisations.concat(this.groups);
      let uncompleteUsergroups = [];
      for (const usergroup of usergroups) {
        if (usergroup.role === null || usergroup.roleStatus === null) {
          uncompleteUsergroups.push(usergroup);
        }
      }
      if (uncompleteUsergroups.length > 0) {
        const uncompleteUsergroupsNames = uncompleteUsergroups.map(el => el.usergroup.display_name).join(', ');
        Swal.fire({
          position: 'center',
          heightAuto: false,
          icon: 'warning',
          html: `<p>Vous avez rattaché l'utilisateur aux organisation(s)/groupe(s) suivants:</p>
            <p><b>${uncompleteUsergroupsNames}</b></p>
            <p>mais vous n'avez pas indiqué le rôle ou le statut 
            pour ce(s) rattachement(s). Ces modifications ne seront pas prises en compte.</p>
            <p>Voulez-vous poursuivre?</p>
          `,
          showCancelButton: true,
          cancelButtonText: 'Annuler',
          showConfirmButton: true,
          confirmButtonText: 'Confirmer',
          confirmButtonColor: '#187CC6',
        }).then((result) => {
          if (result.isCancelled) {
            return false;
          } else if (result.isConfirmed) {
            this.addUser();
          }
        });
      } else {
        this.addUser();
      }
    },

    addUser() {
      this.loading = true;
      const usergroups = this.organisations.concat(this.groups);
      const cleanedUsergroups = usergroups.map((el) => {
        if (el.role !== null && el.roleStatus !== null && el.usergroup.id) {
          return {
            role: el.role,
            status: el.roleStatus,
            usergroup: {
              id: el.usergroup.usergroup ? el.usergroup.usergroup.id : el.usergroup.id
            }
          }
        } else {
          return null;
        }
      }).filter(el => { return el !== null });
      const data = {
        username: usernamify(this.form.first_name.charAt(0).concat('', this.form.last_name)),
        additional_id: this.form.additional_id,
        first_name: this.form.first_name,
        last_name: this.form.last_name,
        email: this.form.email,
        phone_number: this.form.phone_number,
        comments: this.form.comments,
        is_active: true,
        usergroup_roles: cleanedUsergroups
      };
      this.CREATE_USER(data)
      .then(() => {
        if (this.lastCreatedUser) {
          this.SET_LAST_CREATED_USER(null);
          this.SET_CURRENT_FORM({
            id: null,
            form: {}
          });
          this.GET_USERS_LIST({
            direction: null,
            field: null
          }).then(() => {
            this.loading = false;
            this.$router.push({ name: 'Users' });
          })
        } else {
          this.loading = false;
        }
      })
      .catch(() => {
        this.form = this.currentForm;
        this.loading = false;
      });
    },

    setCanAddOrganisation(e) {
      this.canAddOrganisation = e;
    },

    addOrganisation() {
      const position = this.organisations.length + 1;
      this.organisations.push({
        position: position,
        role: null,
        roleStatus: null,
        usergroup: {}
      });
      this.canAddOrganisation = false;
    },

    updateOrganisation(e) {
      const index = this.organisations.findIndex(el => el.position === e.position);
      this.organisations[index] = {
        position: e.position,
        role: e.data.role,
        roleStatus: e.data.roleStatus,
        usergroup: e.data.organisation
      }
    },

    removeOrganisation(e) {
      const index = e - 1;
      this.organisations.splice(index);
      this.canAddOrganisation = true;
    },

    setCanAddGroup(e) {
      this.canAddGroup = e;
    },

    addGroup() {
      const position = this.groups.length + 1;
      this.groups.push({
        position: position,
        role: null,
        roleStatus: null,
        usergroup: {}
      });
      this.canAddGroup = false;
    },

    updateGroup(e) {
      const index = this.groups.findIndex(el => el.position === e.position);
      this.groups[index] = {
        position: e.position,
        role: e.data.role,
        roleStatus: e.data.roleStatus,
        usergroup: e.data.group
      }
    },

    removeGroup(e) {
      const index = e - 1;
      this.groups.splice(index, 1);
      this.canAddGroup = true;
    },
  }
}
</script>

<style lang="less" scoped>

.add-user-form {
  margin-left: max(2em, auto);
  margin-right: max(2em, auto);
}

form {
  min-width: 800px;
  max-width: 1000px;
}

h2 {
  color: @blue;
  margin-top: 0.8em;
  margin-left: 0.5em;
}

h4 {
  color: @blue;
  margin-top: 0.8em;
}

.btn {
  font-size: 1.3em;
  font-weight: 500;
}

</style>
